/*
terminal mode for testing LCD 
used stm32f103rbt6 on stm32vldiscovery
05.10.2017 by Sergi
*/
#include "stm32F10x.h"
#include <stdlib.h>
#include <string.h>

#define DataBusIN 	GPIOB->CRL = 0x88888888,GPIOB->CRH = 0x88888888,GPIOB->ODR = 0xffff
#define DataBusOUT	GPIOB->ODR = 0,GPIOB->CRL = 0x33333333,GPIOB->CRH = 0x33333333
#define ResetH GPIOD->BSRR = GPIO_BSRR_BS2
#define ResetL GPIOD->BSRR = GPIO_BSRR_BR2
#define CsH GPIOC->BSRR = GPIO_BSRR_BS12
#define CsL GPIOC->BSRR = GPIO_BSRR_BR12
#define RsH GPIOC->BSRR = GPIO_BSRR_BS11
#define RsL GPIOC->BSRR = GPIO_BSRR_BR11
#define WrH GPIOC->BSRR = GPIO_BSRR_BS10
#define WrL GPIOC->BSRR = GPIO_BSRR_BR10
#define RdH GPIOA->BSRR = GPIO_BSRR_BS15
#define RdL GPIOA->BSRR = GPIO_BSRR_BR15

volatile int dsec_fl = 0,sec_fl = 0,sec=0;
unsigned char err,recive_ptr = 0;
char recive_buf[255],parser_buf[5][32],tstr[32];

static volatile void delay_us(volatile unsigned long nTime)
{ 
 nTime=6*nTime;
 while(nTime != 0)
 {nTime--;}
};

void init_gpio (void)
{
	RCC->APB2ENR|= RCC_APB2ENR_IOPAEN; 
  RCC->APB2ENR|= RCC_APB2ENR_IOPBEN;
	RCC->APB2ENR|= RCC_APB2ENR_IOPCEN;
	RCC->APB2ENR|= RCC_APB2ENR_IOPDEN;
	RCC->APB2ENR|= RCC_APB2ENR_AFIOEN;
	AFIO->MAPR  |= AFIO_MAPR_SWJ_CFG_JTAGDISABLE; 
	
	GPIOA->CRH |= GPIO_CRH_MODE9; 	// USART Tx
	GPIOA->CRH &=~GPIO_CRH_CNF9;
	GPIOA->CRH |= GPIO_CRH_CNF9_1;
	GPIOA->CRH &=~GPIO_CRH_MODE10; 	// USART Rx
	GPIOA->CRH &=~GPIO_CRH_CNF10;
	GPIOA->CRH |= GPIO_CRH_CNF10_0;
	
	GPIOA->CRH |=GPIO_CRH_MODE15;	//Rd
	GPIOA->CRH &=~GPIO_CRH_CNF15;
	GPIOA->BSRR = GPIO_BSRR_BS15;
	
	GPIOB->CRL = 0x88888888;	//DataBus
	GPIOB->CRH = 0x88888888;
	GPIOB->ODR = 0xffff;
	
	GPIOC->CRH |=GPIO_CRH_MODE8;	//led blue
	GPIOC->CRH &=~GPIO_CRH_CNF8;
	GPIOC->BSRR = GPIO_BSRR_BR8;
	GPIOC->CRH |=GPIO_CRH_MODE9;	//led green
	GPIOC->CRH &=~GPIO_CRH_CNF9;
	GPIOC->BSRR = GPIO_BSRR_BR9;
	GPIOC->CRH |=GPIO_CRH_MODE10;	//Wr
	GPIOC->CRH &=~GPIO_CRH_CNF10;
	GPIOC->BSRR = GPIO_BSRR_BS10;
	GPIOC->CRH |=GPIO_CRH_MODE11;	//Rs
	GPIOC->CRH &=~GPIO_CRH_CNF11;
	GPIOC->BSRR = GPIO_BSRR_BS11;
	GPIOC->CRH |=GPIO_CRH_MODE12;	//Cs
	GPIOC->CRH &=~GPIO_CRH_CNF12;
	GPIOC->BSRR = GPIO_BSRR_BS12;	
	
	GPIOD->CRL |=GPIO_CRL_MODE2;	//Reset
	GPIOD->CRL &=~GPIO_CRL_CNF2;
	GPIOD->BSRR = GPIO_BSRR_BS2;
};

void SysTick_Handler(void)
{
    dsec_fl = 1;
		if (++sec > 9) sec = 0,sec_fl = 1;
	};

void USART1_Init(void)
{
   RCC->APB2ENR |=   RCC_APB2ENR_AFIOEN;               
   RCC->APB2ENR |=   RCC_APB2ENR_USART1EN;              
   USART1->BRR   =   0x0270;                // 115200 b/s to 72MHz
   USART1->CR1  &=  ~USART_CR1_M;                       
   USART1->CR2  &=  ~USART_CR2_STOP;                   
   USART1->CR1  |=   USART_CR1_UE;                     
   USART1->CR1  |=   USART_CR1_TE;                      
   USART1->CR1  |=   USART_CR1_RE;                      
};
 
void USART1_SendData(unsigned char data)
{
	while((USART1->SR & USART_SR_TXE)==0) {} 
	USART1->DR  =  data;                               
};
 
unsigned char USART1_ReciveData(void)
{
	char tmp;
  if (USART1->SR & USART_SR_RXNE) 
	{
		tmp = USART1->DR;
		if ((tmp == 0x0d)||(tmp == 0x0a)||(tmp == 0))
		{
			recive_buf[recive_ptr] = 0;
			recive_ptr = 0;
			return 0;	
		};
		recive_buf[recive_ptr] = tmp;
		recive_ptr++;
		if(recive_ptr > 254) recive_ptr = 0;
	};        
   return 1;                              
};

void USART1_SendString(char *str)
{
	unsigned char i;
	for (i=0;i<strlen(str);i++)
	{
		USART1_SendData(str[i]);
	};
	USART1_SendData(13);USART1_SendData(10);
};
void ltoa(long int n,char *str)
{
	unsigned long i;
 unsigned char j,p;
 i=1000000000L;
 p=0;
 if (n<0)
 {
 n=-n;
 *str++='-';
 };
 do
 {
 j=(unsigned char) (n/i);
 if (j || p || (i==1))
 {
 *str++=j+'0';
 p=1;
 }
 n%=i;
 i/=10L;
 }
 while (i!=0);
 *str=0;
};
 
void reverse(char s[])
{
	int i, j;
	char c;
	for (i = 0, j = strlen(s)-1; i<j; i++, j--) {
	c = s[i];
	s[i] = s[j];
	s[j] = c;
	};
};
 
void itoa(int n, char s[])
{
	int i, sign;
	if ((sign = n) < 0) 
	n = -n; 
	i = 0;
	do { 
	s[i++] = n % 10 + '0'; 
	} while ((n /= 10) > 0); 
	if (sign < 0)
	s[i++] = '-';
	s[i] = '\0';
	reverse(s);
};
unsigned char parser(char *strg,char *start,char *dlim)
{
	char *sp,ts[3];
	unsigned char arg = 0,i;
	for (i=0;i<4;i++) parser_buf[i][0] = 0;
	sp = strtok(strg,dlim);	
		if (strcmp(sp,start) == 0)
		{
			while (sp)
			{
			if (strcmp(sp,start) != 0) 
			{			
				arg++; 
				if (arg < 4) 
				{	
				memcpy(parser_buf[arg],sp,strlen(sp));
				parser_buf[arg][strlen(sp)] = 0;
				};
			};
			sp = strtok(NULL,dlim);
			};
			itoa (arg,ts);
			memcpy(parser_buf[0],ts,strlen(ts));
			parser_buf[0][strlen(ts)] = 0;
			return 0;
		}
		else return 1;
};

unsigned char decode(void)
{
	unsigned char arg,errt = 1,i,k;
	int data,data2;
	if (parser_buf[1][0] == 0)	//help
	{
		USART1_SendString("Help!");
		USART1_SendString("~ RESET");
		USART1_SendString("~ LCD_Write_COM (register) //decimal argument");
		USART1_SendString("~ LCD_Write_DATA (Mbyte,Lbyte) //decimal arguments");
		USART1_SendString("~ LCD_Read_DATA (register) //decimal argument");
		USART1_SendString("~ LCD_Read //repeat read");
		USART1_SendString("~ LCD_Read_All");
		errt = 0;
	};
	if (strcmp(parser_buf[1],"RESET") == 0)
			{
				ResetL;GPIOC->BSRR = GPIO_BSRR_BS8;
				DataBusIN;
				delay_us(1000);
				ResetH;GPIOC->BSRR = GPIO_BSRR_BR8;
				delay_us(1000000);
				errt = 0;
			};
	if ((errt == 1) && (strcmp(parser_buf[1],"LCD_Write_COM") == 0))
			{
				arg = atoi(parser_buf[0]);
				if (arg == 2) 
				{
					data = atoi(parser_buf[2]);
					if((data == 0) && (parser_buf[2][0] != '0')) errt = 3;
					if ((data > 255) || (data < 0)) errt = 4;
					if (errt == 1) {
					DataBusOUT;
					CsL;
					RsL;
					GPIOB->ODR = data;
					WrL;
					delay_us(1);
					WrH;
					CsH;
					DataBusIN;
					errt = 0;
				};
			} else errt = 2;	
			};
	if ((errt == 1) && (strcmp(parser_buf[1],"LCD_Write_DATA") == 0))
			{
				arg = atoi(parser_buf[0]);
				if (arg == 3) 
				{
					data = atoi(parser_buf[2]);
					if((data == 0) && (parser_buf[2][0] != '0')) errt = 3;
					if ((data > 255) || (data < 0)) errt = 4;
					data2 = atoi(parser_buf[3]);
					if((data2 == 0) && (parser_buf[3][0] != '0')) errt = 3;
					if ((data2 > 255) || (data2 < 0)) errt = 4;
					if (errt == 1)
					{
					DataBusOUT;
					CsL;
					RsH;
					GPIOB->ODR = ((int)data<<8) | data2;;
					WrL;
					delay_us(1);
					WrH;
					CsH;
					DataBusIN;
					errt = 0;
					};							
				} else errt = 2;
			};
	if ((errt == 1) && (strcmp(parser_buf[1],"LCD_Read_DATA") == 0))
			{
				arg = atoi(parser_buf[0]);
				if (arg == 2) 
				{
					data = atoi(parser_buf[2]);
					if((data == 0) && (parser_buf[2][0] != '0')) errt = 3;
					if ((data > 255) || (data < 0)) errt = 4;
					if (errt == 1)
						{
							DataBusOUT;
							CsL;
							RsL;
							GPIOB->ODR = data;
							WrL;
							delay_us(1);
							WrH;
							DataBusIN;
							RsH;
							RdL;
							delay_us(1);
							data = GPIOB->IDR;
							RdH;
							itoa((data>>8),tstr);USART1_SendString(tstr);
							itoa((data&0xff),tstr);USART1_SendString(tstr);
							CsH;
						};	
					errt = 0;
				} else errt = 2;
			};
if ((errt == 1) && (strcmp(parser_buf[1],"LCD_Read") == 0))
			{
							CsL;
							DataBusIN;
							RsH;
							RdL;
							delay_us(1);
							data = GPIOB->IDR;
							RdH;					
							itoa((data>>8),tstr);USART1_SendString(tstr);
							itoa((data&0xff),tstr);USART1_SendString(tstr);
							CsH;
					
					errt = 0;		
			};
if ((errt == 1) && (strcmp(parser_buf[1],"LCD_Read_All") == 0))
			{
							CsL;
				for (i=0;i<255;i++)
				{
							DataBusOUT;
							RsL;
							GPIOB->ODR = i;
							WrL;
							delay_us(1);
							WrH;
							DataBusIN;
							RsH;
							RdL;
							delay_us(1);
							data = GPIOB->IDR;
							RdH;
							itoa(i,tstr);
							itoa(i,tstr);
							for (k=0;k<strlen(tstr);k++)	USART1_SendData(tstr[k]);
							USART1_SendData(' ');
							itoa((data>>8),tstr);
							for (k=0;k<strlen(tstr);k++)	USART1_SendData(tstr[k]);
							USART1_SendData(' ');
							itoa((data&0xff),tstr);USART1_SendString(tstr);
				};
							CsH;
					
					errt = 0;		
			};
	parser_buf[0][0] = '0';
	if (errt == 0) USART1_SendString("Ok!"); else
	if (errt == 1) USART1_SendString("Wrong command"); else
	if (errt == 2) USART1_SendString("Missing argument"); else
	if (errt == 3) USART1_SendString("Wrong argument"); else
	if (errt == 4) USART1_SendString("Out of range");
	return errt;
};
int main (void)
{
	init_gpio();
	USART1_Init();
	SysTick_Config(7200000); // 0.1sec
	parser_buf[0][0] = '0';
	USART1_SendString(" ");
	while(1)
	{
		if(dsec_fl)		//for test RUN mode
		{
			dsec_fl = 0;
			GPIOC->BSRR = GPIO_BSRR_BR9;
			if(sec_fl)
			{
			sec_fl = 0;
			GPIOC->BSRR = GPIO_BSRR_BS9;
			};		
		};
		
		if (USART1_ReciveData() == 0) err = parser(recive_buf,"~"," (,)");	//terminal
		if(!err) err = decode(),err = 1;	//execute code
	};
}
